VERSION 5.00
Begin VB.UserControl TrendView 
   ClientHeight    =   1695
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2775
   PropertyPages   =   "TrendView.ctx":0000
   ScaleHeight     =   1695
   ScaleWidth      =   2775
   ToolboxBitmap   =   "TrendView.ctx":001B
   Begin VB.PictureBox picTrend 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H0000FF00&
      Height          =   1695
      Left            =   0
      ScaleHeight     =   1635
      ScaleWidth      =   2715
      TabIndex        =   0
      Top             =   0
      Width           =   2775
   End
End
Attribute VB_Name = "TrendView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Public Enum SmallBorderStyleConstants
    Kein
    Fest_Einfach
End Enum

'Standard-Eigenschaftswerte:
Const m_def_GridColor = &H8000&
Const m_def_GridSpaceX = 10
Const m_def_GridSpaceY = 10
Const m_def_GridStep = 2
Const m_def_MaxValue = 100
Const m_def_MinValue = 0

'Eigenschaftsvariablen:
Dim m_GridColor As OLE_COLOR
Dim m_GridSpaceX As Single
Dim m_GridSpaceY As Single
Dim m_GridStep As Single
Dim m_MaxValue As Single
Dim m_MinValue As Single

'Ereignisdeklarationen:
Event Click() 'MappingInfo=picTrend,picTrend,-1,Click
Attribute Click.VB_Description = "Tritt auf, wenn der Benutzer eine Maustaste ber einem Objekt drckt und wieder loslt."
Event DblClick() 'MappingInfo=picTrend,picTrend,-1,DblClick
Attribute DblClick.VB_Description = "Tritt auf, wenn der Benutzer eine Maustaste ber einem Objekt drckt und wieder loslt und anschlieend erneut drckt und wieder loslt."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=picTrend,picTrend,-1,MouseDown
Attribute MouseDown.VB_Description = "Tritt auf, wenn der Benutzer die Maustaste drckt, whrend ein Objekt den Fokus hat."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=picTrend,picTrend,-1,MouseMove
Attribute MouseMove.VB_Description = "Tritt auf, wenn der Benutzer die Maus bewegt."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=picTrend,picTrend,-1,MouseUp
Attribute MouseUp.VB_Description = "Tritt auf, wenn der Benutzer die Maustaste loslt, whrend ein Objekt den Fokus hat."

'Interne Variablen
Dim points() As Single  'Speichert die ber "setValue" gesetzten Werte


'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Gibt die Hintergrundfarbe zurck, die verwendet wird, oder legt diese fest."
    BackColor = picTrend.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    picTrend.BackColor() = New_BackColor
    drawScale True
    PropertyChanged "BackColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,BorderStyle
Public Property Get BorderStyle() As SmallBorderStyleConstants
Attribute BorderStyle.VB_Description = "Gibt den Rahmenstil fr ein Objekt zurck oder legt diesen fest."
    BorderStyle = picTrend.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As SmallBorderStyleConstants)
    picTrend.BorderStyle() = New_BorderStyle
    drawScale True
    PropertyChanged "BorderStyle"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=12,0,0,10
Public Property Get GridSpaceX() As Single
Attribute GridSpaceX.VB_Description = "Gibt die Anzahl der Einheiten zwischen 2 Gitterlinien in horizontaler Richtung zurck, oder legt diese fest."
Attribute GridSpaceX.VB_ProcData.VB_Invoke_Property = "Grid"
    GridSpaceX = UserControl.ScaleX(m_GridSpaceX, vbPixels, UserControl.ScaleMode)
End Property

Public Property Let GridSpaceX(ByVal New_GridSpaceX As Single)
    m_GridSpaceX = UserControl.ScaleX(New_GridSpaceX, UserControl.ScaleMode, vbPixels)
    drawScale True
    PropertyChanged "GridSpaceX"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=12,0,0,10
Public Property Get GridSpaceY() As Single
Attribute GridSpaceY.VB_Description = "Gibt die Anzahl der Einheiten zwischen 2 Gitterlinien in vertikaler Richtung zurck, oder legt diese fest."
Attribute GridSpaceY.VB_ProcData.VB_Invoke_Property = "Grid"
    GridSpaceY = UserControl.ScaleY(m_GridSpaceY, vbPixels, UserControl.ScaleMode)
End Property

Public Property Let GridSpaceY(ByVal New_GridSpaceY As Single)
    m_GridSpaceY = UserControl.ScaleY(New_GridSpaceY, UserControl.ScaleMode, vbPixels)
    drawScale True
    PropertyChanged "GridSpaceY"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=12,0,0,2
Public Property Get GridStep() As Single
Attribute GridStep.VB_Description = "Gibt die Anzahl der Einheiten zurck, um das sich die Anzeige beim Setzen eines neuen Wertes weiterbewegt, oder legt diese fest."
Attribute GridStep.VB_ProcData.VB_Invoke_Property = "Grid"
    GridStep = UserControl.ScaleY(m_GridStep, vbPixels, UserControl.ScaleMode)
End Property

Public Property Let GridStep(ByVal New_GridStep As Single)
    m_GridStep = UserControl.ScaleY(New_GridStep, UserControl.ScaleMode, vbPixels)
    drawScale True
    PropertyChanged "GridStep"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=12,0,0,100
Public Property Get MaxValue() As Single
Attribute MaxValue.VB_Description = "Gibt den Maximalwert der Y-Achse zurck, oder legt diesen fest."
Attribute MaxValue.VB_ProcData.VB_Invoke_Property = "Grid"
    MaxValue = m_MaxValue
End Property

Public Property Let MaxValue(ByVal New_MaxValue As Single)
    m_MaxValue = New_MaxValue
    PropertyChanged "MaxValue"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=12,0,0,0
Public Property Get MinValue() As Single
Attribute MinValue.VB_Description = "Gibt den Minimalwert der Y-Achse zurck, oder legt diesen fest."
Attribute MinValue.VB_ProcData.VB_Invoke_Property = "Grid"
    MinValue = m_MinValue
End Property

Public Property Let MinValue(ByVal New_MinValue As Single)
    m_MinValue = New_MinValue
    PropertyChanged "MinValue"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,ScaleWidth
Public Property Get innerWidth() As Single
Attribute innerWidth.VB_Description = "Gibt die Anzahl der Einheiten, die fr die Darstellung in vertikaler Richtung verfgbar sind, zurck."
    innerWidth = picTrend.ScaleWidth
End Property

Public Property Let innerWidth(ByVal New_innerWidth As Single)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    picTrend.ScaleWidth() = New_innerWidth
    PropertyChanged "innerWidth"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,ScaleHeight
Public Property Get innerHeight() As Single
Attribute innerHeight.VB_Description = "Gibt die Anzahl der Einheiten, die fr die Darstellung in horizontaler Richtung verfgbar sind, zurck."
    innerHeight = picTrend.ScaleHeight
End Property

Public Property Let innerHeight(ByVal New_innerHeight As Single)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    picTrend.ScaleHeight() = New_innerHeight
    PropertyChanged "innerHeight"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,ScaleMode
Public Property Get ScaleMode() As ScaleModeConstants
Attribute ScaleMode.VB_Description = "Gibt einen Wert zurck, der die Maeinheiten fr Objektkoordinaten bestimmt, wenn Grafikmethoden verwendet werden, oder legt diesen fest."
    ScaleMode = UserControl.ScaleMode
End Property

Public Property Let ScaleMode(ByVal New_ScaleMode As ScaleModeConstants)
    UserControl.ScaleMode() = New_ScaleMode
    picTrend.ScaleMode = New_ScaleMode
    PropertyChanged "ScaleMode"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,ToolTipText
Public Property Get ToolTipText() As String
    ToolTipText = picTrend.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    picTrend.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Gibt den Typ des Mauszeigers zurck, der angezeigt wird, wenn dieser sich ber einem Teil eines Objekts befindet, oder legt diesen fest."
    MousePointer = picTrend.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    picTrend.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,&H00008000&
Public Property Get GridColor() As OLE_COLOR
    GridColor = m_GridColor
End Property

Public Property Let GridColor(ByVal New_GridColor As OLE_COLOR)
    m_GridColor = New_GridColor
    PropertyChanged "GridColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,ForeColor
Public Property Get GraphColor() As OLE_COLOR
    GraphColor = picTrend.ForeColor
End Property

Public Property Let GraphColor(ByVal New_GraphColor As OLE_COLOR)
    picTrend.ForeColor() = New_GraphColor
    PropertyChanged "GraphColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Legt ein benutzerdefiniertes Maussymbol fest."
    Set MouseIcon = picTrend.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set picTrend.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,HasDC
Public Property Get HasDC() As Boolean
Attribute HasDC.VB_Description = "Bestimmt, ob ein eindeutiger Anzeigekontext fr das Steuerelement reserviert wurde."
    HasDC = picTrend.HasDC
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=picTrend,picTrend,-1,hDC
Public Property Get hDC() As Long
    hDC = picTrend.hDC
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=5
Public Sub ShowAbout()
  On Error Resume Next
  frmAbout.Show vbModal
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0
Public Function setValue(Y As Single) As Boolean
Attribute setValue.VB_Description = "Setzt einen neuen Wert. Dieser muss innerhalb der Grenzen MinValue und MaxValue liegen."
    Dim i As Integer
    Dim Step As Single
    Dim maxSteps As Single
    
    If Y < m_MinValue Or Y > m_MaxValue Then
        setValue = False
    Else
        Step = UserControl.ScaleY(m_GridStep, vbPixels, UserControl.ScaleMode)
        maxSteps = picTrend.ScaleWidth / Step

        If UBound(points) >= maxSteps Then
            For i = LBound(points) + 1 To UBound(points)
                points(i - 1) = points(i)
            Next i
        Else
            ReDim Preserve points(UBound(points) + 1)
        End If
        
        points(UBound(points)) = Y
        setValue = True
        drawScale
    End If
End Function

'Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    picTrend.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    picTrend.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    m_GridSpaceX = PropBag.ReadProperty("GridSpaceX", m_def_GridSpaceX)
    m_GridSpaceY = PropBag.ReadProperty("GridSpaceY", m_def_GridSpaceY)
    m_GridStep = PropBag.ReadProperty("GridStep", m_def_GridStep)
    m_MaxValue = PropBag.ReadProperty("MaxValue", m_def_MaxValue)
    m_MinValue = PropBag.ReadProperty("MinValue", m_def_MinValue)
    picTrend.ScaleWidth = PropBag.ReadProperty("innerWidth", 2715)
    picTrend.ScaleHeight = PropBag.ReadProperty("innerHeight", 1635)
    UserControl.ScaleMode = PropBag.ReadProperty("ScaleMode", 1)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    picTrend.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    picTrend.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    picTrend.ForeColor = PropBag.ReadProperty("GraphColor", &HFF00&)
    m_GridColor = PropBag.ReadProperty("GridColor", m_def_GridColor)
End Sub

'Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", picTrend.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BorderStyle", picTrend.BorderStyle, 1)
    Call PropBag.WriteProperty("GridSpaceX", m_GridSpaceX, m_def_GridSpaceX)
    Call PropBag.WriteProperty("GridSpaceY", m_GridSpaceY, m_def_GridSpaceY)
    Call PropBag.WriteProperty("GridStep", m_GridStep, m_def_GridStep)
    Call PropBag.WriteProperty("MaxValue", m_MaxValue, m_def_MaxValue)
    Call PropBag.WriteProperty("MinValue", m_MinValue, m_def_MinValue)
    Call PropBag.WriteProperty("innerWidth", picTrend.ScaleWidth, 2715)
    Call PropBag.WriteProperty("innerHeight", picTrend.ScaleHeight, 1635)
    Call PropBag.WriteProperty("ScaleMode", UserControl.ScaleMode, 1)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", picTrend.MousePointer, 0)
    Call PropBag.WriteProperty("ToolTipText", picTrend.ToolTipText, "")
    Call PropBag.WriteProperty("GraphColor", picTrend.ForeColor, &HFF00&)
    Call PropBag.WriteProperty("GridColor", m_GridColor, m_def_GridColor)
End Sub

'Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()
    m_GridSpaceX = m_def_GridSpaceX
    m_GridSpaceY = m_def_GridSpaceY
    m_GridStep = m_def_GridStep
    m_MaxValue = m_def_MaxValue
    m_MinValue = m_def_MinValue
    
    picTrend.ScaleMode = UserControl.ScaleMode
    
    ReDim points(0)
    points(0) = 0
    m_GridColor = m_def_GridColor
End Sub

Private Sub UserControl_Initialize()
    UserControl_InitProperties
    drawScale
End Sub

Private Sub UserControl_Resize()
    picTrend.Height = UserControl.ScaleHeight
    picTrend.Width = UserControl.ScaleWidth
    drawScale
End Sub

Private Sub UserControl_Show()
    drawScale
End Sub

Private Sub picTrend_Click()
    RaiseEvent Click
End Sub

Private Sub picTrend_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub picTrend_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub picTrend_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub picTrend_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub drawScale(Optional NoMove As Boolean = False)
    Dim i As Integer
    Dim SpaceX As Single
    Dim SpaceY As Single
    Dim Step As Single
    Dim fromPoint As Single
    Dim toPoint As Single
    
    Static Steps As Single
    
    picTrend.Cls
    
    SpaceX = UserControl.ScaleX(m_GridSpaceX, vbPixels, UserControl.ScaleMode)
    SpaceY = UserControl.ScaleY(m_GridSpaceY, vbPixels, UserControl.ScaleMode)
    Step = UserControl.ScaleY(m_GridStep, vbPixels, UserControl.ScaleMode)
    
    For i = picTrend.ScaleHeight To 0 Step -SpaceY
        picTrend.Line (0, i)-(picTrend.ScaleWidth, i), m_GridColor
    Next i

    For i = SpaceX - 1 To picTrend.ScaleWidth Step SpaceX
        picTrend.Line (i, 0)-(i, picTrend.ScaleHeight), m_GridColor
    Next i
    
    If Not NoMove Then
        Steps = Steps + Step
        If Steps > picTrend.ScaleWidth Then Steps = 0
    End If
    
    If UBound(points) > 0 Then
        For i = LBound(points) + 1 To UBound(points)
            fromPoint = picTrend.ScaleHeight / (m_MaxValue - m_MinValue) * (points(i - 1) - m_MinValue)
            toPoint = picTrend.ScaleHeight / (m_MaxValue - m_MinValue) * (points(i) - m_MinValue)
        
            picTrend.Line (picTrend.ScaleWidth - (UBound(points) - i + 1) * Step, picTrend.ScaleHeight - fromPoint)-(picTrend.ScaleWidth - (UBound(points) - i) * Step, picTrend.ScaleHeight - toPoint), picTrend.ForeColor
        Next i
    End If
End Sub
